/*:
 * @plugindesc Plugin used to implement static Actor battlers.
 * @author Fomar0153
 *
 * @help The battlers should be placed in the sv_actors folder.
 *
 * @param screenX
 * @desc Starting position for actor battlers.
 * @default 600
 *
 * @param xOffset
 * @desc Starting position for actor battlers.
 * @default 32
 *
 * @param screenY
 * @desc Starting position for actor battlers.
 * @default 280
 *
 * @param yOffset
 * @desc Starting position for actor battlers.
 * @default 48
 *
 */

var Fomar = Fomar || {};
Fomar.ActorBattlers = {};
Fomar.ActorBattlers.parameters = PluginManager.parameters('ActorBattlers');

Fomar.ActorBattlers.screenX = Number(Fomar.ActorBattlers.parameters['screenX']);
Fomar.ActorBattlers.xOffset = Number(Fomar.ActorBattlers.parameters['xOffset']);
Fomar.ActorBattlers.screenY = Number(Fomar.ActorBattlers.parameters['screenY']);
Fomar.ActorBattlers.yOffset = Number(Fomar.ActorBattlers.parameters['yOffset']);


Game_Actor.prototype.screenX = function() {
  return Fomar.ActorBattlers.screenX + this.index() * Fomar.ActorBattlers.xOffset;
};

Game_Actor.prototype.screenY = function() {
  return Fomar.ActorBattlers.screenY + this.index() * Fomar.ActorBattlers.yOffset;
};

Game_Actor.prototype.battlerHue = function() {
  return 0;
};

Spriteset_Battle.prototype.createActors = function() {
  this._actorSprites = [];
  for (var i = 0; i < $gameParty.maxBattleMembers(); i++) {
    this._actorSprites[i] = new Sprite_Enemy($gameParty.members());
    this._battleField.addChild(this._actorSprites[i]);
  }
};

Spriteset_Battle.prototype.createActors = function() {
  var actors = $gameParty.battleMembers();
  var sprites = [];
  for (var i = 0; i < actors.length; i++) {
    sprites[i] = new Sprite_Enemy(actors[i]);
  }
  sprites.sort(this.compareEnemySprite.bind(this));
  for (var j = 0; j < sprites.length; j++) {
    this._battleField.addChild(sprites[j]);
  }
  this._actorSprites = sprites;
};

Fomar.ActorBattlers.Sprite_Enemy_loadBitmap = Sprite_Enemy.prototype.loadBitmap;
Sprite_Enemy.prototype.loadBitmap = function(name, hue) {
  if (this._enemy.isActor()){
    this.bitmap = ImageManager.loadSvActor(name);
  } else {
    Fomar.ActorBattlers.Sprite_Enemy_loadBitmap.call(this,name,hue);
  }
};
